Summary:       A portable foreign function interface library
Name:          libffi
Version:       3.4.4
Release:       3%{?dist}
License:       MIT
URL:           http://sourceware.org/libffi
Source0:       https://github.com/libffi/libffi/releases/download/v%{version}/libffi-%{version}.tar.gz
BuildRequires: make, gcc, gcc-c++, dejagnu

%description
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.  A
calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call a
given function.  `Libffi' can be used in such programs to provide a
bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions.  This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface.  A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language.  The
`libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface.  A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%package       devel
Summary:       Development files for %{name}
Requires:      %{name} = %{version}-%{release}, pkgconfig

%description   devel
This package provides libraries and header files for
developers who use %{name}.

%prep
%setup -q

%build
# https://gitlab.haskell.org/ghc/ghc/-/issues/20051
# https://gitlab.gnome.org/GNOME/gobject-introspection/-/merge_requests/283
%configure --disable-static --disable-exec-static-tramp
%make_build

%check
%make_build check

%install
%make_install

find %{buildroot} -name '*.la' -delete
rm -f %{buildroot}%{_infodir}/dir

%files
%license LICENSE
%doc README.md
%{_libdir}/libffi.so.8*

%files devel
%{_libdir}/pkgconfig/*.pc
%{_libdir}/*.so
%{_includedir}/ffi*.h
%{_infodir}/libffi.info.*
%{_mandir}/man3/*.gz

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.4-3
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.4-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 1 2023 Shuo Wang <abushwang@tencent.com> - 3.4.4-1
- update to 3.4.4

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.2-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jul 12 2022 cunshunxia <cunshunxia@tencent.com> - 3.4.2-1
- initial build
